/* CEAppManager.h				 
 *
 * This is the basic controller of the App. It manages all hig abstraction
 * tasks for the panel, documents and connections to the outside.
 *
 * Usage: This is not a very reusable object. 
 *
 * Written by: 		Thomas Engel
 * Created:    		23.10.1993 (Copyleft)
 * Last modified: 	07.05.1994
 */

#import <appkit/appkit.h>

@interface CEAppManager:Object
{
	// For all those style settings...

	id	textFontField;
	id	textFontColorWell;
	id	methodNameField;
	id	methodNameColorWell;
	id	headlinesFontField;
	id	headlinesFontColorWell;
	id	exampleCodeFontField;
	id	exampleCodeFontColorWell;
	id	blankLinesFontField;
	id	blankLinesFontColorWell;
	id	sourceFontField;
	id	sourceFontColorWell;
	id	keywordsFontField;
	id	keywordsFontColorWell;
	id	typecastFontField;
	id	typecastFontColorWell;	
	id	remarkFontField;
	id	remarkFontColorWell;	
	id	bugNoteFontField;
	id	bugNoteFontColorWell;

	id	classDocTemplateView;
	id	methodDocuTemplateView;
	
	id	docuTemplateWindow;
	id	docuTemplateTextView;
}

// Some methods need to get the app started..

- appWillInit:sender;
- appDidInit:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- appDidBecomeActive:sender;
- appWillTerminate:sender;
- (BOOL)_closeAllWindows;
- addToReleasePool:anObject;

- (int)openFile:(char *)path onHost:(char *)host atTrueLine:(int *)line;

// Here we do the handling of our Panels & Tools

- showInfo:sender;
- showPreferences:sender;
- preferences;

// Here we have the methods the control our document. They work via the
// first responder chain.

- open:sender;
- new:sender;
- save:sender;
- saveAs:sender;
- saveTo:sender;
- saveAll:sender;
- revert:sender;
- close:sender;

- print:sender;

// Handling text styles

- setTextFontStyle:sender;
- setMethodNameFontStyle:sender;
- setParameterFontStyle:sender;
- setMathSymbolFontStyle:sender;
- setHeadlinesFontStyle:sender;
- setExampleCodeFontStyle:sender;
- setBlankLinesFontStyle:sender;
- setSourceFontStyle:sender;
- setKeywordsFontStyle:sender;
- setTypecastFontStyle:sender;
- setRemarkFontStyle:sender;
- setBugNoteFontStyle:sender;
- _setSelectionFont:aFont andColor:aColor;

// Providing more defaults...

- copyClassDocuTemplate;
- copyMethodDocuTemplate;

- windowDidBecomeKey:sender;

@end

/*
 * History: 13.01.95 Bla.
 *
 *
 * Hints: This Object could be defined as a subclass of a general docManager
 *		 like the one provided by the NeXT-miniexamples...Maybe later or never
 *
 *
 * Bugs: No bugs and birds seen....
 */